/**
  *  \file server/jsonout.h
  *  \brief Server: JSON output
  */
#ifndef C2SERVER_SERVER_JSONOUT_H
#define C2SERVER_SERVER_JSONOUT_H

#include "cpluslib/string.h"
#include "cpluslib/types.h"

/** Simple JSON formatter. This offers routines to write the basic
    JSON productions with proper escaping. It also formats the output
    to avoid overlong lines. */
class JsonWriter {
    bool need_comma_before_next_obj;
    string_t line;

    void flushComma();
 public:
    JsonWriter();

    void startArray(string_t name);
    void startArray();
    void endArray();
    void writeString(string_t value);
    void writeInt(int32_t value);
    void writeNull();

    void startObject(string_t name);
    void startObject();
    void endObject();
    void writeString(string_t name, string_t value);
    void writeInt(string_t name, int32_t value);
    void writeNull(string_t name);

    void start();
    void end();
};

#endif
